<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XVpnGroupMember StructType
 * @subpackage Structs
 */
class XVpnGroupMember extends AbstractStructBase
{
    /**
     * The vpnGatewayName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var XFkType
     */
    public $vpnGatewayName;
    /**
     * The priority
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $priority;
    /**
     * Constructor method for XVpnGroupMember
     * @uses XVpnGroupMember::setVpnGatewayName()
     * @uses XVpnGroupMember::setPriority()
     * @param XFkType $vpnGatewayName
     * @param string $priority
     */
    public function __construct(XFkType $vpnGatewayName = null, $priority = null)
    {
        $this
            ->setVpnGatewayName($vpnGatewayName)
            ->setPriority($priority);
    }
    /**
     * Get vpnGatewayName value
     * @return XFkType
     */
    public function getVpnGatewayName()
    {
        return $this->vpnGatewayName;
    }
    /**
     * Set vpnGatewayName value
     * @param XFkType $vpnGatewayName
     * @return XVpnGroupMember
     */
    public function setVpnGatewayName(XFkType $vpnGatewayName = null)
    {
        $this->vpnGatewayName = $vpnGatewayName;
        return $this;
    }
    /**
     * Get priority value
     * @return string
     */
    public function getPriority()
    {
        return $this->priority;
    }
    /**
     * Set priority value
     * @uses XInteger::valueIsValid()
     * @uses XInteger::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $priority
     * @return XVpnGroupMember
     */
    public function setPriority($priority = null)
    {
        // validation for constraint: enumeration
        if (!XInteger::valueIsValid($priority)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $priority, implode(', ', XInteger::getValidValues())), __LINE__);
        }
        $this->priority = $priority;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XVpnGroupMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
